/* 
 * Author: Konrad Rozanski
 */

#ifndef MPL3115A2alt_H
#define	MPL3115A2alt_H

//#define FCY 7370000/2
#define FSCL 100
 
// default I2C address is 0x60 (7 bits) or 0110 0000
#define MPL3115A2_ADDRESS_WRITE 0xC0      // write  --> 1100 0000
#define MPL3115A2_ADDRESS_READ 0xC1       // read   --> 1100 0001

// Registers

#define MPL3115A2_REGISTER_STATUS 0x00
#define MPL3115A2_REGISTER_PRESSURE_MSB 0x01
#define MPL3115A2_REGISTER_PRESSURE_CSB 0x02
#define MPL3115A2_REGISTER_PRESSURE_LSB 0x03

#define MPL3115A2_REGISTER_TEMP_MSB 0x04
#define MPL3115A2_REGISTER_TEMP_LSB 0x05

#define MPL3115A2_REGISTER_DR_STATUS 0x06

#define MPL3115A2_OUT_P_DELTA_MSB 0x07
#define MPL3115A2_OUT_P_DELTA_CSB 0x08
#define MPL3115A2_OUT_P_DELTA_LSB 0x09

#define MPL3115A2_OUT_T_DELTA_MSB 0x0A
#define MPL3115A2_OUT_T_DELTA_LSB 0x0B

#define MPL3115A2_WHOAMI 0x0C

#define MPL3115A2_BAR_IN_MSB 0x14
#define MPL3115A2_BAR_IN_LSB 0x15

//status register bits

#define MPL3115A2_REGISTER_STATUS_TDR 0x02
#define MPL3115A2_REGISTER_STATUS_PDR 0x04
#define MPL3115A2_REGISTER_STATUS_PTDR 0x08
// 

// Pt data register bits
#define MPL3115A2_PT_DATA_CFG 0x13
#define MPL3115A2_PT_DATA_CFG_TDEFE 0x01
#define MPL3115A2_PT_DATA_CFG_PDEFE 0x02
#define MPL3115A2_PT_DATA_CFG_DREM 0x04

// control registers

#define MPL3115A2_CTRL_REG1 0x26
#define MPL3115A2_CTRL_REG2 0x27
#define MPL3115A2_CTRL_REG3 0x28
#define MPL3115A2_CTRL_REG4 0x29
#define MPL3115A2_CTRL_REG5 0x2A

//control register bits

#define MPL3115A2_CTRL_REG1_SBYB 0x01
#define MPL3115A2_CTRL_REG1_OST 0x02
#define MPL3115A2_CTRL_REG1_RST 0x04
#define MPL3115A2_CTRL_REG1_RAW 0x40
#define MPL3115A2_CTRL_REG1_ALT 0x80
#define MPL3115A2_CTRL_REG1_BAR 0x00

// oversample values

#define MPL3115A2_CTRL_REG1_OS1 0x00
#define MPL3115A2_CTRL_REG1_OS2 0x08
#define MPL3115A2_CTRL_REG1_OS4 0x10
#define MPL3115A2_CTRL_REG1_OS8 0x18
#define MPL3115A2_CTRL_REG1_OS16 0x20
#define MPL3115A2_CTRL_REG1_OS32 0x28
#define MPL3115A2_CTRL_REG1_OS64 0x30
#define MPL3115A2_CTRL_REG1_OS128 0x38

void config_MPL3115A2(void);
unsigned int read_values_MPL3115A2(void);

#endif