/* 
 * Author: Konrad Rozanski
 */
#include <xc.h>
#include <stdio.h>
#include "I2C.h"

void config_I2C (void) {    
    //I2C1BRG = 0x1F;
    I2C1BRG = 0x15;
    I2C1CONbits.ON = 1;    
}

void startI2C1 (void) {
    I2C1CONbits.SEN = 1;
    while (I2C1CONbits.SEN == 1);
}

void rstartI2C1 (void) {
    I2C1CONbits.RSEN = 1;
    while (I2C1CONbits.RSEN == 1);
}

BYTE putI2C1 (BYTE C) {
    I2C1TRN = C;
    while (I2C1STATbits.TRSTAT); //1 --> transmit in progress, 0 --> completed
    
    return (I2C1STATbits.ACKSTAT); //when ACK bit is not received from slave --> 1
}

void stopI2C1 (void) {
    I2C1CONbits.PEN = 1;        //stopping
    while (I2C1CONbits.PEN == 1);   
}

BYTE getI2C1 (BYTE C) {
    BYTE inByte;
    
    while (I2C1CON & 0x1F);     //wait while we aren't ready or in the middle of important stuff
    I2C1CONbits.ON = 1;       //Receive enable
    I2C1CONbits.RCEN = 1;       //Receive enable
    
    while (!I2C1STATbits.RBF);  //1-->receive is complete and buffer is full, 0-->not ready don't do anything
    inByte = I2C1RCV;           //Get data from receive register
    
    while (I2C1CON & 0x1F);
    I2C1CONbits.ACKDT = C;      //acknowledge data bit --> (1) yes we data, (0) no we didn't get data
    I2C1CONbits.ACKEN = 1;      //initiate sequence for saying what we put in ACKDT
    
    while (I2C1CONbits.ACKEN);  //wait until we've finished the above sequence 
    
    return (inByte);            //return what we just read
}