/* 
 * Author: Konrad Rozanski
 */

#ifndef SPI_H
#define	SPI_H

#include <xc.h>

#define SPI2_DUMMY_DATA 0xFF

/* Pins for transceiver control signals */
// RD4 --> pin 52
#define TRAN_SCE LATDbits.LATD4 
#define TRAN_SCE_PIN TRISDbits.TRISD4
// RD7 --> pin 55
#define TRAN_RESET LATDbits.LATD7 
#define TRAN_RESET_PIN TRISDbits.TRISD7

#define IN 1
#define OUT 0

#define LOW 0
#define HIGH 1

typedef unsigned char BYTE;

void config_SPI(void);
void TranDisable(void);
void TranEnable(void);
BYTE SPI_IO(BYTE o);

#endif	