#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "SPI.h"
#include "SX1276.h"
#include "I2C.h"
#include "GPS.h"
#include "MPL3115A2alt.h"

void main(void) {        
    struct Temperature temp;
    char temp_string[60];
    char *GPS_data;
    char GPS_header [100] = "\r$$$$GPS DATA: ";
    char ending[7] = "\n";
    
    config_MPL3115A2();
    config_SPI();
    
    while(!begin(915000000)){
        wait_ms(1000);
    }
    
    /* Transmitting Code */
    while(1){
        while(beginPacket(false) == 0){
            wait_ms(250);
        }
        
        temp = read_values_MPL3115A2();
        GPS_data = read_values_GPS();
        strcat(GPS_header, GPS_data);
        strcat(GPS_header, ending);
        
        sprintf(temp_string, "\n\r$$$$The altitude is: %d", 78);
        
        beginPacket(false);
        sendString(GPS_header);
        endPacket(false);
        wait_ms(1000);
        
        beginPacket(false);
        sendString(temp_string);
        endPacket(false);
        wait_ms(1000);
    }
}